Index: /pjproject/trunk/pjsip/src/pjsip/sip_transport.c
===================================================================
--- /pjproject/trunk/pjsip/src/pjsip/sip_transport.c	(revision 53)
+++ /pjproject/trunk/pjsip/src/pjsip/sip_transport.c	(revision 54)
@@ -1483,201 +720,132 @@
 
 	/* Call the transport manager's upstream message callback.
-	*/
-	(*mgr->message_callback)(mgr->endpt, rdata);
+	 */
+	mgr->msg_cb(mgr->endpt, PJ_SUCCESS, rdata);
+
 
 finish_process_fragment:
-	rdata->len -= msg_fragment_size;
-	if (rdata->len > 0) {
-	    pj_memmove(rdata->packet, rdata->packet+msg_fragment_size, rdata->len);
-	    PJ_LOG(4,(tr->obj_name, "Processing next fragment, size=%d bytes", rdata->len));
-	}
-
-    }	/* while (rdata->len > 0) */
-
-on_return:
-    /* Reset the pool and rdata */
-    rdata_pool = rdata->pool;
-    pj_pool_reset(rdata_pool);
-    rdata = pj_pool_alloc( rdata_pool, sizeof(*rdata) );
-    rdata->len = 0;
-    rdata->transport = tr;
-    rdata->pool = rdata_pool;
-    tr->rdata = rdata;
-
-    /* Read the next packet. */
-    rdata->addr_len = sizeof(rdata->addr);
-    if (tr->type == PJSIP_TRANSPORT_UDP) {
-	pj_ssize_t size = PJSIP_MAX_PKT_LEN;
-	pj_ioqueue_recvfrom(tr->key, &tr->rdata->op_key,
-			    tr->rdata->packet, &size, 0, 
-			    &rdata->addr, &rdata->addr_len);
-	PJ_TODO(HANDLE_IMMEDIATE_DATA);
-    }
-
-#if PJ_HAS_TCP
-    /* The next 'if' should have been 'else if', but we need to put the
-       label inside the '#if PJ_HAS_TCP' block to avoid 'unreferenced label' warning.
+	total_processed += msg_fragment_size;
+	current_pkt += msg_fragment_size;
+	remaining_len -= msg_fragment_size;
+
+    }	/* while (rdata->pkt_info.len > 0) */
+
+
+    return total_processed;
+}
+
+
+/*
+ * pjsip_tpmgr_alloc_transport()
+ *
+ * Get transport suitable to communicate to remote. Create a new one
+ * if necessary.
+ */
+PJ_DEF(pj_status_t) pjsip_tpmgr_alloc_transport( pjsip_tpmgr *mgr,
+						 pjsip_transport_type_e type,
+						 const pj_sockaddr_in *remote,
+						 pjsip_transport **p_transport)
+{
+    transport_key key;
+    pjsip_transport *transport;
+    pjsip_tpfactory *factory;
+    pj_status_t status;
+
+    pj_lock_acquire(mgr->lock);
+
+    /* First try to get exact destination. */
+    key.type = (pj_uint8_t)type;
+    key.zero = 0;
+    key.addr = pj_ntohl(remote->sin_addr.s_addr);
+    key.port = pj_ntohs(remote->sin_port);
+
+    transport = pj_hash_get(mgr->table, &key, sizeof(key));
+    if (transport != NULL) {
+	unsigned flag = pjsip_transport_get_flag_from_type(type);
+	
+	/* For datagram transports, try lookup with zero address. */
+	if (flag & PJSIP_TRANSPORT_DATAGRAM) {
+	    key.addr = 0;
+	    key.port = 0;
+
+	    transport = pj_hash_get(mgr->table, &key, sizeof(key));
+	}
+    }
+    
+    if (transport != NULL) {
+	/*
+	 * Transport found!
+	 */
+	pjsip_transport_add_ref(transport);
+	pj_lock_release(mgr->lock);
+	*p_transport = transport;
+	return PJ_SUCCESS;
+    }
+
+    /*
+     * Transport not found!
+     * Find factory that can create such transport.
      */
-tcp_read_packet:
-    if (tr->type == PJSIP_TRANSPORT_TCP) {
-	pj_ssize_t size = PJSIP_MAX_PKT_LEN - tr->rdata->len;
-	pj_ioqueue_recv( tr->key, &tr->rdata->op_key,
-			 tr->rdata->packet + tr->rdata->len,
-			 &size, 0);
-	PJ_TODO(HANDLE_IMMEDIATE_DATA_1);
-    }
-#endif
-}
-
-static void transport_mgr_on_idle( pjsip_transport_mgr *mgr )
-{
-    pj_time_val now;
+    factory = mgr->factory_list.next;
+    while (factory != &mgr->factory_list) {
+	if (factory->type == type)
+	    break;
+	factory = factory->next;
+    }
+
+    if (factory == &mgr->factory_list) {
+	/* No factory can create the transport! */
+	pj_lock_release(mgr->lock);
+	return PJSIP_EUNSUPTRANSPORT;
+    }
+
+    /* Request factory to create transport. */
+    status = factory->create_transport(factory, mgr, mgr->endpt,
+				       mgr->ioqueue, remote, p_transport);
+
+    pj_lock_release(mgr->lock);
+    return status;
+}
+
+/**
+ * Dump transport info.
+ */
+PJ_DEF(void) pjsip_tpmgr_dump_transports(pjsip_tpmgr *mgr)
+{
+#if PJ_LOG_MAX_LEVEL >= 3
     pj_hash_iterator_t itr_val;
     pj_hash_iterator_t *itr;
 
-
-    /* Get time for comparing transport's close time. */
-    pj_gettimeofday(&now);
-    if (now.sec < mgr->next_idle_check.sec) {
-	return;
-    }
-
-    /* Acquire transport manager's lock. */
-    pj_mutex_lock(mgr->mutex);
-
-    /* Update next idle check. */
-    mgr->next_idle_check.sec += MGR_IDLE_CHECK_INTERVAL;
-
-    /* Iterate all transports, and close transports that are not used for
-       some periods.
-     */
-    itr = pjsip_transport_first(mgr, &itr_val);
-    while (itr != NULL) {
-	pj_hash_iterator_t *next;
-	pjsip_transport_t *transport;
-	
-	transport = pjsip_transport_this(mgr, itr);
-
-	next = pjsip_transport_next(mgr, itr);
-
-	if (pj_atomic_get(transport->ref_cnt)==0 && 
-	    PJ_TIME_VAL_LTE(transport->close_time, now))
-	{
-	    destroy_transport(mgr, transport);
-	}
-
-	itr = next;
-    }
-
-    /* Release transport manager's lock. */
-    pj_mutex_unlock(mgr->mutex);
-}
-
-static void on_ioqueue_read(pj_ioqueue_key_t *key, 
-			    pj_ioqueue_op_key_t *op_key, 
-			    pj_ssize_t bytes_read)
-{
-    pjsip_transport_t *t;
-    t = pj_ioqueue_get_user_data(key);
-
-    handle_received_data( t->mgr, t, bytes_read );
-}
-
-static void on_ioqueue_write(pj_ioqueue_key_t *key, 
-			     pj_ioqueue_op_key_t *op_key, 
-			     pj_ssize_t bytes_sent)
-{
-    PJ_UNUSED_ARG(key);
-    PJ_UNUSED_ARG(bytes_sent);
-
-    /* Completion of write operation. 
-     * Do nothing.
-     */
-}
-
-static void on_ioqueue_accept(pj_ioqueue_key_t *key, 
-			      pj_ioqueue_op_key_t *op_key, 
-			      pj_sock_t newsock,
-			      int status)
-{
-#if PJ_HAS_TCP
-    pjsip_transport_t *t;
-    t = pj_ioqueue_get_user_data(key);
-
-    handle_new_connection( t->mgr, t, status );
-#else
-    PJ_UNUSED_ARG(key);
-    PJ_UNUSED_ARG(status);
+    pj_lock_acquire(mgr->lock);
+
+    itr = pj_hash_first(mgr->table, &itr_val);
+    if (itr) {
+	PJ_LOG(3, (THIS_FILE, " Dumping transports:"));
+
+	do {
+	    char src_addr[128], dst_addr[128];
+	    int src_port, dst_port;
+	    pjsip_transport *t;
+
+	    t = pj_hash_this(mgr->table, itr);
+	    pj_native_strcpy(src_addr, pj_inet_ntoa(t->local_addr.sin_addr));
+	    src_port = pj_ntohs(t->local_addr.sin_port);
+
+	    pj_native_strcpy(dst_addr, pj_inet_ntoa(t->rem_addr.sin_addr));
+	    dst_port = pj_ntohs(t->rem_addr.sin_port);
+
+	    PJ_LOG(3, (THIS_FILE, "  %s %s %s:%d --> %s:%d (refcnt=%d)", 
+		       t->type_name,
+		       t->obj_name,
+		       src_addr, src_port,
+		       dst_addr, dst_port,
+		       pj_atomic_get(t->ref_cnt)));
+
+	    itr = pj_hash_next(mgr->table, itr);
+	} while (itr);
+    }
+
+    pj_lock_release(mgr->lock);
 #endif
 }
 
-static void on_ioqueue_connect(pj_ioqueue_key_t *key, int status)
-{
-#if PJ_HAS_TCP
-    pjsip_transport_t *t;
-    t = pj_ioqueue_get_user_data(key);
-
-    handle_connect_completion( t->mgr, t, status);
-#else
-    PJ_UNUSED_ARG(key);
-    PJ_UNUSED_ARG(status);
-#endif
-}
-
-
-/*
- * Poll for events.
- */
-PJ_DEF(int) pjsip_transport_mgr_handle_events( pjsip_transport_mgr *mgr,
-					       const pj_time_val *req_timeout )
-{
-    int event_count;
-    int break_loop;
-    int result;
-    pj_time_val timeout;
-
-    PJ_LOG(5, (LOG_TRANSPORT_MGR, "pjsip_transport_mgr_handle_events()"));
-
-    event_count = 0;
-    break_loop = 0;
-    timeout = *req_timeout;
-    do {
-	result = pj_ioqueue_poll( mgr->ioqueue, &timeout);
-	if (result == 1) {
-	    ++event_count;
-
-	    /* Break the loop. */
-	    //if (timeout.msec==0 && timeout.sec==0) {
-	    	break_loop = 1;
-	    //}
-
-	} else {
-	    /* On idle, cleanup transport. */
-	    transport_mgr_on_idle(mgr);
-
-	    break_loop = 1;
-	}
-	timeout.sec = timeout.msec = 0;
-    } while (!break_loop);
-
-    return event_count;
-}
-
-
-PJ_DEF(pj_hash_iterator_t*) pjsip_transport_first( pjsip_transport_mgr *mgr,
-						   pj_hash_iterator_t *it )
-{
-    return pj_hash_first(mgr->transport_table, it);
-}
-
-PJ_DEF(pj_hash_iterator_t*) pjsip_transport_next( pjsip_transport_mgr *mgr,
-						  pj_hash_iterator_t *itr )
-{
-    return pj_hash_next(mgr->transport_table, itr);
-}
-
-PJ_DEF(pjsip_transport_t*) pjsip_transport_this( pjsip_transport_mgr *mgr,
-						 pj_hash_iterator_t *itr )
-{
-    return pj_hash_this(mgr->transport_table, itr);
-}
